<?php

namespace Modules\St\Http\Controllers;

use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Modules\Sc\Entities\PayTerm;
use Modules\St\Entities\Currency;

class ErpSettingController extends Controller
{



    public function disablePayTerm(Request $request, $id)
    {
        try {
            $value = $request->get('status');
            $object = PayTerm::find($id);
            $object->status = $value;
            $update = $object->save();
            if ($update) {
                $responseBody = $this->responseBody(true, "disablePayTerm", "updated", null);
            }
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "disablePayTerm", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function disableCurrency(Request $request, $id)
    {
        try {
            $value = $request->get('status');
            $object = Currency::find($id);
            $object->status = $value;
            $update = $object->save();
            if ($update) {
                $responseBody = $this->responseBody(true, "disableCurrency", "updated", null);
            }
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "disableCurrency", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }




    public function savePayTerm(Request $request){
        try {
            $object = new PayTerm();
            $object->pay_term = $request->get('value');
            $object->status = true;
            $save = $object->save();

            if ($save) {
                $responseBody = $this->responseBody(true, "savePayTerm", "saved", null);
            }
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "savePayTerm", $exception, null);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function saveCurrency(Request $request){
        try {
            $object = new Currency();
            $object->currency = $request->get('currency');
            $object->iso_code = $request->get('iso');
            $object->symbol = $request->get('symbol');
            $object->status = true;
            $save = $object->save();

            if ($save) {
                $responseBody = $this->responseBody(true, "saveCurrency", "saved", null);
            }
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "saveCurrency", $exception, null);
        }
        return response()->json(["data" => $responseBody]);
    }




    public function getAllPayTerm(){
        try {
            $pay_terms = PayTerm::all();
            $responseBody = $this->responseBody(true, "SettingsController", "getAllPayTerm", $pay_terms);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "SettingsController", "error", null);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function getAllCurrency(){
        try {
            $currency = Currency::all();
            $responseBody = $this->responseBody(true, "SettingsController", "getAllCurrency", $currency);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "SettingsController", "error", null);
        }
        return response()->json(["data" => $responseBody]);
    }




    public function getPayTerm($id){
        try {
            $pay_term = PayTerm::find($id);
            $responseBody = $this->responseBody(true, "SettingsController", "getPayTerm", $pay_term);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "SettingsController", "error", null);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function getCurrency($id){
        try {
            $currency = Currency::find($id);
            $responseBody = $this->responseBody(true, "SettingsController", "getCurrency", $currency);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "SettingsController", "error", null);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function updatePayTerm(Request $request,$id){
        try {
            $pay_term = PayTerm::find($id);
            $pay_term->pay_term = $request->get('value');
            $pay_term->update();
            $responseBody = $this->responseBody(true, "SettingsController", "updatePayTerm",true);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "SettingsController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function updateCurrency(Request $request,$id){
        try {
            $currency = Currency::find($id);
            $currency->currency = $request->get('currency');
            $currency->iso_code = $request->get('iso');
            $currency->symbol = $request->get('symbol');
            $currency->update();
            $responseBody = $this->responseBody(true, "SettingsController", "updateCurrency",true);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "SettingsController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }









        /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
