<?php

namespace Modules\St\Http\Controllers;

use Exception;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\DB;
use Modules\St\Entities\OutsideFactory;
use Modules\St\Entities\Suppliers;

class OutsideFactoryController extends Controller
{
    public function allSuppliers()
    {
        try {
            $Suppliers = Suppliers::all();
            $Suppliers_arr = [];

            foreach ($Suppliers as $Supplier) {
                array_push($Suppliers_arr, ["img" => "", "id" => $Supplier['supplier_id'], "value" => $Supplier['supplier_name']]);
            }

            $responseBody = $this->responseBody(true, "OutsideFactoryController", "allSuppliers", $Suppliers_arr);
        } catch (Exception $exception) {
            $responseBody =  $this->responseBody(false, "OutsideFactoryController", "allSuppliers", $exception->getMessage());
        }

        return response()->json(["data" => $responseBody]);
    }










    public function saveOutsideFactory(Request $request)
    {
        try {
            $outsideFactory = new OutsideFactory();
            $outsideFactory->factory_id = $request->get('factory_id');
            $outsideFactory->name = $request->get('name');
            $outsideFactory->supplier_id = $request->get('supplier_id');
            $outsideFactory->status = 1;
            $outsideFactory->save();
            $responseBody = $this->responseBody(true, "OutsideFactoryController", "saveOutsideFactory", true);
        } catch (Exception $exception) {
            $responseBody =  $this->responseBody(false, "OutsideFactoryController", "saveOutsideFactory", $exception->getMessage());
        }

        return response()->json(["data" => $responseBody]);
    }



    public function updateOutsideFactory(Request $request, $id)
    {
        try {
            $outsideFactory = OutsideFactory::find($id);
            $outsideFactory->factory_id = $request->get('factory_id');
            $outsideFactory->name = $request->get('name');
            $outsideFactory->supplier_id = $request->get('supplier_id');
            $outsideFactory->update();
            $responseBody = $this->responseBody(true, "OutsideFactoryController", "updateOutsideFactory", true);
        } catch (Exception $exception) {
            $responseBody =  $this->responseBody(false, "OutsideFactoryController", "updateOutsideFactory", $exception->getMessage());
        }

        return response()->json(["data" => $responseBody]);
    }



    public function changeStatus(Request $request, $id)
    {

        try {
            $outsideFactory = OutsideFactory::find($id);
            $outsideFactory->status = $request->get('status');
            $status = $outsideFactory->update();
            if ($status) {
                $responseBody = $this->responseBody(true, "OutsideFactoryController", "changeStatus", null);
            } else {
                $responseBody = $this->responseBody(false, "OutsideFactoryController", "changeStatus", null);
            }
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "OutsideFactoryController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }



    public function deleteOutsideFactory($id)
    {

        try {
            $outsideFactory = OutsideFactory::find($id);
            if ($outsideFactory->delete()) {
                $responseBody = $this->responseBody(true, "OutsideFactoryController", "deleteOutsideFactory", null);
            } else {
                $responseBody = $this->responseBody(false, "OutsideFactoryController", "deleteOutsideFactory", null);
            }
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "OutsideFactoryController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }



    public function allOutsideFactory()
    {
        try {
            $query = 'SELECT st_outside_factories.*,st_suppliers.supplier_name AS supplier FROM st_outside_factories INNER JOIN st_suppliers ON st_outside_factories.supplier_id = st_suppliers.supplier_id ORDER BY st_outside_factories.outside_factory_id DESC';
            $result = DB::select($query);
            $responseBody = $this->responseBody(true, "OutsideFactoryController", "allOutsideFactory", $result);
        } catch (Exception $exception) {
            $responseBody =  $this->responseBody(false, "OutsideFactoryController", "allOutsideFactory", $exception->getMessage());
        }

        return response()->json(["data" => $responseBody]);
    }



    public function getOutsideFactory($id)
    {
        try {
            // $query = 'SELECT st_outside_factories.*,st_suppliers.supplier_name AS supplier FROM st_outside_factories INNER JOIN st_suppliers ON st_outside_factories.supplier_id = st_suppliers.supplier_id WHERE st_outside_factories.outside_factory_id = "' . $id . '"';
            //$result = DB::select($query);
            $outsideFactory = OutsideFactory::find($id);
            $outsideFactory->supplier = "";
            $supplier = Suppliers::find($outsideFactory->supplier_id);
            if ($supplier) {
                $outsideFactory->supplier = $supplier->supplier_name;
            }
            $responseBody = $this->responseBody(true, "OutsideFactoryController", "getOutsideFactory", $outsideFactory);
        } catch (Exception $exception) {
            $responseBody =  $this->responseBody(false, "OutsideFactoryController", "getOutsideFactory", $exception->getMessage());
        }

        return response()->json(["data" => $responseBody]);
    }






    //responcebody
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
