
$(document).ready(function () {
    resetProduct();
    loadSettings();
    var product_id = getUrlParameter('id');
    var action = getUrlParameter('action');
    if (product_id != '' && action == 'edit' || action == 'view') {
        getProduct(product_id);
        if (action == 'edit') {
            $('#btnAction').show();
            $('#btnAction').text('Update');
            $('#btnReset').show();
        }
        if (action == 'view') {
            $('#btnAction').text('view');
            $('#btnAction').hide();
            $('#btnReset').show();
        }
    }

    $('#btnAction').on('click', function (event) {

        $('#' + isRequiredInputsSave().tab).trigger('click');



        if ($(this).text() == 'Save') {
            if (isRequiredInputsSave().isRequired) {
                if (isDuplicateID($('#txtProductId').val()) == "true") {
                    showWarningMessage('Duplicate product id');
                    return;
                }
                save();
            }
        } else if ($(this).text() == 'Update') {
            if (isRequiredInputsUpdate().isRequired) {
                update(product_id);
            }
        }


    });

    $('#selcGroupLevel1').on('change', function () {
        var id = $(this).val();
        loadGroupLevel2(id);
    });

    $('#selcGroupLevel2').on('change', function () {
        var id1 = $('#selcGroupLevel1').val();
        var id2 = $(this).val();
        loadGroupLevel3(id1, id2);
    });

    permissionCheck();
    loadUnitOfMesurement()
});
function loadUnitOfMesurement(){
    $.ajax({
        type: 'GET',
        url: '/st/product/loadUnitOfMesurement',
        async:false,
        success: function(response){
            console.log(response.data.result)
            if (response.data.success) {
                var html = "";
                $.each(response.data.result, function(index, value){

                    html += '<option value="'+value.id+'" > '+value.name+' </option>';
                });
                $('#txtUnitOfMesurement').append(html);


            }
        }, error: function(data){
            console.log(data);
            console.log('something went wrong');
        }
    });
}


function getUrlParameter(name) {
    name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
    var regex = new RegExp('[\\?&]' + name + '=([^&#]*)');
    var results = regex.exec(location.search);
    return results === null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '));
};


function resetProduct() {
    $('#productForm').trigger("reset");
    $('#pills-general-tab').trigger('click');
    $('#btnAction').text('Save');
    $('#btnAction').show();
    $('#btnReset').hide();
    $('#selcGroupLevel2').empty();
    $('#selcGroupLevel2').append('<option selected="true"  disabled="" value="">Select Group Level2</option>');
    $('#selcGroupLevel3').empty();
    $('#selcGroupLevel3').append('<option selected="true"  disabled="" value="">Select Group Level3</option>');
}

function loadSettings() {
    $.ajax({
        type: "GET",
        url: "/st/product/settings",
        async: false,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var collection = response.data.result;
                appendSettings(collection);

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}


function getProduct(id) {
    //$('#btnAction').show();
    $.ajax({
        type: "GET",
        url: "/st/product/getProduct/" + id,
        async: true,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                setProduct(response.data.result);
                permissionCheck();
            } else {
                showErrorMessage('Product not found...!');
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}



function setProduct(product) {
    console.log(product);

    var product_id = product.product_id;
    var product_name = product.product_name;
    var product_description = product.product_description;
    var unit_of_mesure = product.uom_id;
    var sku = product.sku;
    var group_level_1 = product.group_id_level_1;
    var group_level_2 = product.group_id_level_2;
    var group_level_3 = product.group_id_level_3;
    var reorder_level = product.reorder_level;
    var reorder_quantity = product.reorder_quantity;
    var product_type = product.product_type_id;
    var gl_analysis = product.gl_analysis_id;
    var notes = product.notes;

    var sms = product.sms_alert;
    var notification = product.notification;
    var email = product.email_alert;
    var active = product.status;
    var weight = product.weight;
    var size = product.size;


    loadGroupLevel2(group_level_1);
    loadGroupLevel3(group_level_1, group_level_2);

    $('#txtProductId').val(product_id);
    $('#txtProductName').val(product_name);
    $('#txtDescription').val(product_description);
    $('#txtUnitOfMesurement').val(unit_of_mesure);
    $('#txtSKU').val(sku);
    $('#txtReorderLevel').val(reorder_level);
    $('#txtReorderQuantity').val(reorder_quantity);
    $('#txtNote').val(notes);
    $('#txtWeight').val(weight);
    $('#txtSize').val(size);


    if (group_level_1) {
        setSelectedOption("selcGroupLevel1", group_level_1);
    }

    if (group_level_2) {
        setSelectedOption("selcGroupLevel2", group_level_2);
    }

    if (group_level_3) {
        setSelectedOption("selcGroupLevel3", group_level_3);
    }

    if (product_type) {
        setSelectedOption("selcProductType", product_type);
    }

    if (gl_analysis) {
        setSelectedOption("selcGlAnalysis", gl_analysis);
    }


    if (sms) {
        $('#checkSms').prop('checked', true);
    } else {
        $('#checkSms').prop('checked', false);
    }

    if (email) {
        $('#checkEmail').prop('checked', true);
    } else {
        $('#checkEmail').prop('checked', false);
    }

    if (notification) {
        $('#checkNotification').prop('checked', true);
    } else {
        $('#checkNotification').prop('checked', false);
    }

    if (active) {
        $('#checkActive').prop('checked', true);
    } else {
        $('#checkActive').prop('checked', false);
    }


}



function isDuplicateID(id) {

    var bool = false;
    $.ajax({
        type: "GET",
        url: "/st/product/isDuplicate/" + id,
        async: true,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            bool = response;

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

    return bool;
}



function save() {
    $.ajax({
        type: "POST",
        url: '/st/product/save',
        data: getFormData(),
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                showSuccessMessage("Product has been saved successfully...");
                resetProduct();


            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}


function update(id) {
    $.ajax({
        type: 'PUT',
        url: '/st/product/update/' + id,
        data: getPutData(),
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage('Product has been updated successfully...');
                location.href = "/st/product_list";

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });

}



function getFormData() {
    var _token = $("input[name='_token']").val();
    var productId = $('#txtProductId').val();
    var productName = $('#txtProductName').val();
    var description = $('#txtDescription').val();
    var unitOfMesurement = $('#txtUnitOfMesurement').val();
    var sku = $('#txtSKU').val();
    var grouplevel1 = $('#selcGroupLevel1').val();
    var groupLevel2 = $('#selcGroupLevel2').val();
    var groupLevel3 = $('#selcGroupLevel3').val();
    var reorderLevel = $('#txtReorderLevel').val();
    var reorderQuantity = $('#txtReorderQuantity').val();
    var productType = $('#selcProductType').val();
    var glAnalysis = $('#selcGlAnalysis').val();
    var note = $('#txtNote').val();
    var weight = $('#txtWeight').val();
    var size = $('#txtSize').val();



    var sms = $('#checkSms').is(':checked');
    var email = $('#checkEmail').is(':checked');
    var notification = $('#checkNotification').is(':checked');
    var active = $('#checkActive').is(':checked');


    var formData = new FormData();
    formData.append("_token", _token);
    formData.append("productId", productId);
    formData.append("productName", productName);
    formData.append("description", description);
    formData.append("unitOfMesurement", unitOfMesurement);
    formData.append("sku", sku);
    formData.append("grouplevel1", grouplevel1);
    formData.append("groupLevel2", groupLevel2);
    formData.append("groupLevel3", groupLevel3);
    formData.append("reorderLevel", reorderLevel);
    formData.append("reorderQuantity", reorderQuantity);
    formData.append("productType", productType);
    formData.append("glAnalysis", glAnalysis);
    formData.append("note", note);
    formData.append("sms", sms);
    formData.append("email", email);
    formData.append("notification", notification);
    formData.append("active", active);
    formData.append("weight", weight);
    formData.append("size", size);

    return formData;
}





function getPutData() {
    var _token = $("input[name='_token']").val();
    var productId = $('#txtProductId').val();
    var productName = $('#txtProductName').val();
    var description = $('#txtDescription').val();
    var unitOfMesurement = $('#txtUnitOfMesurement').val();
    var sku = $('#txtSKU').val();
    var grouplevel1 = $('#selcGroupLevel1').val();
    var groupLevel2 = $('#selcGroupLevel2').val();
    var groupLevel3 = $('#selcGroupLevel3').val();
    var reorderLevel = $('#txtReorderLevel').val();
    var reorderQuantity = $('#txtReorderQuantity').val();
    var productType = $('#selcProductType').val();
    var glAnalysis = $('#selcGlAnalysis').val();
    var note = $('#txtNote').val();
    var weight = $('#txtWeight').val();
    var size = $('#txtSize').val();


    var sms = $('#checkSms').is(':checked');
    var email = $('#checkEmail').is(':checked');
    var notification = $('#checkNotification').is(':checked');
    var active = $('#checkActive').is(':checked');


    var formData = {
        "_token": _token,
        "productId": productId,
        "productName": productName,
        "description": description,
        "unitOfMesurement": unitOfMesurement,
        "sku": sku,
        "grouplevel1": grouplevel1,
        "groupLevel2": groupLevel2,
        "groupLevel3": groupLevel3,
        "reorderLevel": reorderLevel,
        "reorderQuantity": reorderQuantity,
        "productType": productType,
        "glAnalysis": glAnalysis,
        "note": note,
        "sms": sms,
        "email": email,
        "notification": notification,
        "active": active,
        'weight':weight,
        'size':size
    };
    return formData;
}




/**
* appendSettings
* This function is used append option to combobox.
* @param collection This is the paramter to combobox elements item
*/
function appendSettings(collection) {

    $.each(collection['grouplevel1'], function (index, value) {
        $('#selcGroupLevel1').append('<option value="' + value['group_level_1_id'] + '">' + value['group_level_1'] + '</option>');
    });

    $.each(collection['groupLevel2'], function (index, value) {
        $('#selcGroupLevel2').append('<option value="' + value['group_level_2_id'] + '">' + value['group_level_2'] + '</option>');
    });

    $.each(collection['groupLevel3'], function (index, value) {
        $('#selcGroupLevel3').append('<option value="' + value['group_level_3_id'] + '">' + value['group_level_3'] + '</option>');
    });

    $.each(collection['productType'], function (index, value) {
        $('#selcProductType').append('<option value="' + value['product_type_id'] + '">' + value['product_type'] + '</option>');
    });

    $.each(collection['glAnalysis'], function (index, value) {
        $('#selcGlAnalysis').append('<option value="' + value['gl_post_id'] + '">' + value['gl_post'] + '</option>');
    });

}



function loadGroupLevel2(id) {
    $.ajax({
        type: "GET",
        url: "/st/product/groupLevel2/" + id,
        async: true,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var collection = response.data.result;
                $('#selcGroupLevel2').empty();
                $('#selcGroupLevel2').append('<option selected="true"  disabled="" value="">Select Group Level2</option>');
                appendSettings(collection);

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}



function loadGroupLevel3(id1, id2) {
    $.ajax({
        type: "GET",
        url: "/st/product/groupLevel3/" + id1 + "/" + id2,
        async: true,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var collection = response.data.result;
                $('#selcGroupLevel3').empty();
                $('#selcGroupLevel3').append('<option selected="true"  disabled="" value="">Select Group Level3</option>');
                appendSettings(collection);

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}


function setSelectedOption(id, valueToSelect) {
    let element = document.getElementById(id);
    element.value = valueToSelect;
}


function permissionCheck() {
    if ($('#btnAction').text() == 'Save') {
        if (add_permission != 1) {
            $('#btnAction').hide();
        } else {
            $('#btnAction').show();
        }
    } else if ($('#btnAction').text() == 'Update') {
        if (edit_permission != 1) {
            $('#btnAction').hide();
        } else {
            $('#btnAction').show();
        }
    }
}



/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}
